package com.yizhi.album.application.feign;

import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

@FeignClient(name = "album", contextId = "AlbumJobHandleClient")
public interface AlbumJobHandleClient {

    /**
     * 定时任务执行实际的处理逻辑类
     * 定时任务业务逻辑处理
     *
     * @param
     * @return
     */
    @GetMapping("/remote/album/albumUnLock")
    @ApiOperation(value = "定时解锁专辑课程", response = String.class)
    public void unLockCourse();
}
