package com.yizhi.album.application.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

@Data
public class AlbumVo {

    @ApiModelProperty(value = "专辑主键id")
    private Long id;

    @ApiModelProperty(value = "专辑名称")
    private String name;

    @ApiModelProperty(value = "0 未上架 1 已上架 2 草稿")
    private Integer shelves;

    @ApiModelProperty(value = "分类id")
    private Long classifyId;
    
    @ApiModelProperty(value = "分类名称")
    private String classifyName;

    @ApiModelProperty(value = "专辑封面图")
    private String image;

    @ApiModelProperty(value = "专辑介绍")
    private String description;

    private String tags;

    @ApiModelProperty(value = "可见范围 0 游客 1 平台用户 2 指定范围")
    private Integer scope;

    @ApiModelProperty(value = "评论设置0上架评论及评分1关闭评论")
    private Integer commentEnable;

    private Long companyId;

    private Long orgId;

    private Long siteId;

    private Long createById;

    private String createByName;

    @ApiModelProperty("创建时间，列表的时候用")
    private Date createTime;

    private Long updateById;

    private String updateByName;

    private Date updateTime;
    
    @ApiModelProperty(value = "专辑资料 0显示 1不显示 默认显示")
	private Integer documentEnable;

    @ApiModelProperty(value = "0:默认未删除；1表示删除")
	private Integer delFlg;

    @ApiModelProperty(value = "完成状态 0连载中 1已完结")
	private Integer overed;

    @ApiModelProperty(value = "显示模式 0全部显示 1只显示已解锁课程 默认全部显示")
	private Integer display;
    
    @ApiModelProperty(value = "连载中最近解锁时间")
    private String newest;
    
    @ApiModelProperty(value = "课程时长")
    private Long duration;
    
    @ApiModelProperty(value = "学习人数")
    private Integer studyCount;
    
    @ApiModelProperty(value = "主题列表")
    private List<AlThemeVo> list;
    
    @ApiModelProperty(value = "删除的主题id")
    private List<Long> deleteList;
    
    @ApiModelProperty(value = "评论人数")
    private Integer commentCount;
    
    @ApiModelProperty(value = "订阅人数")
    private Integer subscribeCount;
    
    @ApiModelProperty(value = "未解锁课程数")
    private Integer lockNum;

    @ApiModelProperty(value = "专辑是否在日历中显示 默认为 0：不开启 1：开启")
    private Integer enableTask;

    @ApiModelProperty(value = "日历任务开始时间：enable-task不为0时，有值")
    private Date taskStartDate;

    @ApiModelProperty(value = "日历任务结束时间：enable-task不为0时，有值")
    private Date taskEndDate;
}
