package com.yizhi.album.application.controller;


import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.yizhi.album.application.domain.ClassifyStrategy;
import com.yizhi.album.application.service.IClassifyStrategyService;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.core.application.context.RequestContext;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;

/**
 * <p>
 * 专辑分类策略 前端控制器
 * </p>
 *
 * @author hc123
 * @since 2019-12-30
 */
@RestController
@RequestMapping("/classifyStrategy")
public class ClassifyStrategyController {

	@Autowired
	private IClassifyStrategyService classifyStrategyService;
	
	@Autowired
	com.yizhi.application.orm.id.IdGenerator IdGenerator;
	@GetMapping("/update")
	public com.yizhi.album.application.vo.domain.ClassifyStrategy update(@RequestParam(value = "type", required = true) Integer type, @RequestParam(value = "status", required = true) Integer status) {
		RequestContext context = ContextHolder.get();
		Long siteId = context.getSiteId();
		Long companyId = context.getCompanyId();
		Long accountId = context.getAccountId();
		String name = context.getAccountName();
		Date date = new Date();
		ClassifyStrategy strategy = new ClassifyStrategy();
		strategy.setSiteId(siteId);
		strategy.setCompanyId(companyId);
		EntityWrapper<ClassifyStrategy> wrapper = new EntityWrapper<ClassifyStrategy>(strategy);
		ClassifyStrategy one = classifyStrategyService.selectOne(wrapper);
		if (one==null) {
			one = new ClassifyStrategy();
			one.setId(IdGenerator.generate());
			one.setType(type);
			one.setStatus(status);
			one.setCreateById(accountId);
			one.setCreateByName(name);
			one.setCreateTime(date);
			one.setCompanyId(companyId);
			one.setSiteId(siteId);
			classifyStrategyService.insert(one);
		}else {
			one.setType(type);
			one.setStatus(status);
			one.setUpdateById(accountId);
			one.setUpdateByName(name);
			one.setUpdateTime(date);
			classifyStrategyService.updateById(one);
		}
		com.yizhi.album.application.vo.domain.ClassifyStrategy classifyStrategy = new com.yizhi.album.application.vo.domain.ClassifyStrategy();
		BeanUtils.copyProperties(one, classifyStrategy);
		return classifyStrategy;
	}
	
	@GetMapping("/get")
	public com.yizhi.album.application.vo.domain.ClassifyStrategy get(@RequestParam(value = "companyId", required = true) Long companyId, @RequestParam(value = "siteId", required = true) Long siteId) {
		ClassifyStrategy strategy = new ClassifyStrategy();
		strategy.setSiteId(siteId);
		strategy.setCompanyId(companyId);
		EntityWrapper<ClassifyStrategy> wrapper = new EntityWrapper<ClassifyStrategy>(strategy);
		ClassifyStrategy one = classifyStrategyService.selectOne(wrapper);

		com.yizhi.album.application.vo.domain.ClassifyStrategy classifyStrategy = new com.yizhi.album.application.vo.domain.ClassifyStrategy();
		BeanUtils.copyProperties(strategy, classifyStrategy);
		return classifyStrategy;
	}
}

