package com.yizhi.album.application.controller.remote;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.yizhi.album.application.domain.AlTheme;
import com.yizhi.album.application.domain.AlThemeActivity;
import com.yizhi.album.application.domain.Album;
import com.yizhi.album.application.service.IAlThemeActivityService;
import com.yizhi.album.application.service.IAlThemeService;
import com.yizhi.album.application.service.IAlbumService;
import com.yizhi.album.application.vo.AlThemeVo;
import com.yizhi.album.application.vo.AlbumVo;
import com.yizhi.application.orm.id.IdGenerator;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.util.application.beanutil.BeanCopyListUtil;
import org.apache.commons.collections.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 主题中的课程 前端控制器
 * </p>
 *
 * @author hc123
 * @since 2019-12-30
 */
@RestController
@RequestMapping("/remote/alThemeActivity")
public class AlThemeActivityController {

	private Logger logger = LoggerFactory.getLogger(AlThemeActivityController.class);

	@Autowired
	private IAlbumService albumService;

	@Autowired
	private IAlThemeActivityService alThemeActivityService;

	@Autowired
	private IAlThemeService alThemeService;

	@Autowired
	IdGenerator idGenerator;

	@PostMapping("/save")
	public Boolean sava(@RequestBody AlbumVo vo) {
		RequestContext context = ContextHolder.get();
		Long siteId = context.getSiteId();
		Long accountId = context.getAccountId();
		Long companyId = context.getCompanyId();
		Long orgId = context.getOrgId();
		Date date = new Date();
		String name = context.getAccountName();
		List<AlThemeVo> themeVos = vo.getList();
		Album album = albumService.selectById(vo.getId());
		album.setOvered(vo.getOvered());
		album.setUpdateById(accountId);
		album.setUpdateByName(name);
		album.setUpdateTime(date);
		album.setDisplay(vo.getDisplay());
		albumService.updateById(album);
		//删除主题
		if (CollectionUtils.isNotEmpty(vo.getDeleteList())) {
			for(Long id:vo.getDeleteList()) {
				AlTheme theme = alThemeService.selectById(id);
				theme.setDeleted(1);
				theme.setUpdateById(accountId);
				theme.setUpdateByName(name);
				theme.setUpdateTime(date);
				alThemeService.updateById(theme);
			}
		}
		if (CollectionUtils.isNotEmpty(themeVos)) {
			for(AlThemeVo themeVo:themeVos) {
				//删除主题中活动
				if (CollectionUtils.isNotEmpty(themeVo.getDeleteList())) {
					for(Long id:themeVo.getDeleteList()) {
						AlThemeActivity activity = alThemeActivityService.selectById(id);
						activity.setDeleted(1);
						activity.setUpdateById(accountId);
						activity.setUpdateByName(name);
						activity.setUpdateTime(date);
						alThemeActivityService.updateById(activity);
					}
				}
				AlTheme theme = new AlTheme();
				if (themeVo.getId()==null||themeVo.getId()==0) {
					if (!alThemeService.vaidName(null,vo.getId(), themeVo.getName(), siteId)) {
						return Boolean.FALSE;
					}
					theme.setId(idGenerator.generate());
					theme.setCreateById(accountId);
					theme.setCreateByName(name);
					theme.setCreateTime(date);
					theme.setSiteId(siteId);
					theme.setCompanyId(companyId);
					theme.setOrgId(orgId);
				}else {
					theme.setId(themeVo.getId());
					if (!alThemeService.vaidName(themeVo.getId(),vo.getId(), themeVo.getName(), siteId)) {
						return Boolean.FALSE;
					}
				}
				theme.setAlbumId(themeVo.getAlbumId());
				theme.setName(themeVo.getName());
				theme.setSort(themeVo.getSort());
				theme.setDeleted(0);
				theme.setUpdateById(accountId);
				theme.setUpdateByName(name);
				theme.setUpdateTime(date);
				alThemeService.insertOrUpdate(theme);
				for(com.yizhi.album.application.vo.domain.AlThemeActivity activityVo:themeVo.getActivities()) {
					AlThemeActivity activity = new AlThemeActivity();
					if (activityVo.getId()==null||activityVo.getId()==0) {
						activity.setId(idGenerator.generate());
						activity.setCreateById(accountId);
						activity.setCreateByName(name);
						activity.setCreateTime(date);
						activity.setSiteId(siteId);
						activity.setCompanyId(companyId);
						activity.setOrgId(orgId);
					}else {
						activity.setId(activityVo.getId());
					}
					activity.setAlbumId(activityVo.getAlbumId());
					activity.setThemeId(theme.getId());
					activity.setThemeName(theme.getName());
					activity.setRelationId(activityVo.getRelationId());
					activity.setRelationCode(activityVo.getRelationCode());
					activity.setName(activityVo.getName());
					activity.setSort(activityVo.getSort());
					activity.setDeleted(0);
//					activity.setUnlock(activityVo.getUnlock());
                    activity.setUnlock(vo.getShelves() == 1 && activityVo.getUnlock() == 1 ? 0 : activityVo.getUnlock());
					activity.setUnlockTime(activityVo.getUnlockTime());
					alThemeActivityService.insertOrUpdate(activity);
				}
			}
		}
		return Boolean.TRUE;
	}
	
	@GetMapping("/delete")
	public Boolean delete(@RequestParam(name = "id")Long id) {
		RequestContext context = ContextHolder.get();
		Long accountId = context.getAccountId();
		String name = context.getAccountName();
		Date date = new Date();
		boolean b = false;
		AlThemeActivity activity = alThemeActivityService.selectById(id);
		if (activity!=null) {
			activity.setDeleted(1);
			activity.setUpdateById(accountId);
			activity.setUpdateByName(name);
			activity.setUpdateTime(date);
			 b = alThemeActivityService.updateById(activity);
		}
		return b;
	}
	
	@PostMapping("/sortActivity")
	public Boolean sortActivity(@RequestBody List<AlThemeActivity> list) {
		logger.info("管理端传入要排序的ID列表==========================:" + list);
		return alThemeActivityService.sortActivity(list);
	}
	
	@PostMapping("/unLock")
	public Boolean unLock(@RequestBody AlThemeActivity activity) {
		logger.info("管理端传入定时解锁的活动==========================:" + activity);
		return alThemeActivityService.updateById(activity);
	}
	
	@GetMapping("/list")
	public AlbumVo list(@RequestParam(name = "albumId")Long albumId){
		AlbumVo albumVo = new AlbumVo();
		Album album = albumService.selectById(albumId);
		albumVo.setId(album.getId());
		albumVo.setName(album.getName());
		albumVo.setShelves(album.getShelves());
		albumVo.setClassifyId(album.getClassifyId());
		albumVo.setImage(album.getImage());
		albumVo.setDescription(album.getDescription());
		albumVo.setTags(album.getTags());
		albumVo.setScope(album.getScope());
		albumVo.setCommentEnable(album.getCommentEnable());
		albumVo.setDocumentEnable(album.getDocumentEnable());
		albumVo.setOvered(album.getOvered());
		albumVo.setDisplay(album.getDisplay());
		List<AlThemeVo> list = new ArrayList<AlThemeVo>();
		AlTheme theme = new AlTheme();
		theme.setAlbumId(albumId);
		theme.setDeleted(0);
		EntityWrapper<AlTheme> wrapper = new EntityWrapper<AlTheme>(theme);
		wrapper.orderBy("sort", true);
		List<AlTheme> themes = alThemeService.selectList(wrapper);
		for(AlTheme alTheme:themes) {
			AlThemeVo themeVo = new AlThemeVo();
			themeVo.setAlbumId(albumId);
			themeVo.setId(alTheme.getId());
			themeVo.setName(alTheme.getName());
			List<AlThemeActivity> activities = new ArrayList<>();
			AlThemeActivity activity = new AlThemeActivity();
			activity.setThemeId(alTheme.getId());
			activity.setDeleted(0);
			EntityWrapper<AlThemeActivity> entityWrapper = new EntityWrapper<AlThemeActivity>(activity);
			entityWrapper.orderBy("sort", true);
			activities = alThemeActivityService.selectList(entityWrapper);
			activities.forEach(e->e.setThemeName(alTheme.getName()));
			List<com.yizhi.album.application.vo.domain.AlThemeActivity> alThemeActivities =
					BeanCopyListUtil.copyListProperties(activities, com.yizhi.album.application.vo.domain.AlThemeActivity::new);
			themeVo.setActivities(alThemeActivities);
			list.add(themeVo);
		}
		albumVo.setList(list);
		return albumVo;
	}
}
