package com.yizhi.album.application.controller.remote;

import com.yizhi.album.application.service.IAlbumService;
import com.yizhi.album.application.util.BuildJob;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author hc123
 * @since 2019-12-30
 */
@RestController(value = "remoteJobHandleController1")
@Api(tags = "专辑涉及job接口")
@RequestMapping("/remote/album")
public class RemoteJobHandleController {

    @Autowired
    private BuildJob buildJob;
    
    @Autowired
    private IAlbumService albumService;
    
    private Logger logger = LoggerFactory.getLogger(RemoteJobHandleController.class);
    
    /**
     * 定时任务执行实际的处理逻辑类
     * 定时任务业务逻辑处理
     *
     * @param
     * @return
     */
    @GetMapping("/albumUnLock")
    @ApiOperation(value = "定时解锁专辑课程", response = String.class)
    public void unLockCourse() {
        try {
            logger.info("开始处理定时任务");
            albumService.unLockCourse();
        } catch (Exception e) {
            e.printStackTrace();
            logger.info("定时任务处理异常");
        }
    }

    @GetMapping("/buildJob")
    @ApiOperation(value = "构建一个job任务，默认每五分钟处理，也可指定cron表达式", response = String.class)
    public void buildJob(@RequestParam(value = "hanldeTime",required = false)Date hanldeTime ) throws Exception {
        if (hanldeTime == null){
            buildJob.buildJobDefault("定时解锁专辑课程，默认每五分钟处理一次");
        }else {
            buildJob.buildJob(new Date().toString(),hanldeTime);
        }
    }
}
