package com.yizhi.album.application.domain;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * <p>
 * 主题中的课程
 * </p>
 *
 * @author hc123
 * @since 2019-12-30
 */
@Data
@ApiModel(value = "AlThemeActivity", description = "主题中的课程")
@TableName("al_theme_activity")
public class AlThemeActivity {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键id")
	private Long id;

    @ApiModelProperty(value = "冗余专辑id")
	@TableField("album_id")
	private Long albumId;

    @ApiModelProperty(value = "主题id")
	@TableField("theme_id")
	private Long themeId;

    @ApiModelProperty(value = "主题名称")
	private String themeName;
    
    @ApiModelProperty(value = "课程id")
	@TableField("relation_id")
	private Long relationId;

    @ApiModelProperty(value = "课程code")
	@TableField("relation_code")
	private String relationCode;

    @ApiModelProperty(value = "课程名称")
	private String name;

    @ApiModelProperty(value = "排序")
	private Integer sort;

    @ApiModelProperty(value = "是否删除（1是，0否），默认否")
	private Integer deleted;

    @ApiModelProperty(value = "解锁状态 0已解锁 1发布及解锁 2自定义解锁")
	private Integer unlock;

    @ApiModelProperty(value = "解锁时间")
	@TableField("unlock_time")
	private Date unlockTime;

    @ApiModelProperty(value = "创建者id")
	@TableField(value = "create_by_id", fill = FieldFill.INSERT)
	private Long createById;

    @ApiModelProperty(value = "创建者名称")
	@TableField(value = "create_by_name", fill = FieldFill.INSERT)
	private String createByName;

    @ApiModelProperty(value = "创建时间")
	@TableField(value = "create_time", fill = FieldFill.INSERT)
	private Date createTime;

    @ApiModelProperty(value = "更新者id")
	@TableField(value = "update_by_id", fill = FieldFill.INSERT)
	private Long updateById;

    @ApiModelProperty(value = "修改者名称")
	@TableField(value = "update_by_name", fill = FieldFill.INSERT)
	private String updateByName;

    @ApiModelProperty(value = "修改时间")
	@TableField(value = "update_time", fill = FieldFill.INSERT)
	private Date updateTime;

    @ApiModelProperty(value = "站点id")
	@TableField("site_id")
	private Long siteId;

    @ApiModelProperty(value = "组织id")
	@TableField("org_id")
	private Long orgId;

    @ApiModelProperty(value = "企业id")
	@TableField("company_id")
	private Long companyId;



}
