package com.yizhi.album.application.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 专辑分类
 * </p>
 *
 * @author hc123
 * @since 2019-12-30
 */
@Data
@ApiModel(value = "AlbumClassify", description = "专辑分类")
@TableName("album_classify")
public class AlbumClassify extends Model<AlbumClassify>{

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "主键")
	private Long id;

    @ApiModelProperty(value = "父id ")
	@TableField("parent_id")
	private Long parentId;

    @ApiModelProperty(value = "层级")
	private Integer layer;

    @ApiModelProperty(value = "名称")
	private String name;

    @ApiModelProperty(value = "分类编码")
	private String code;

    @ApiModelProperty(value = "备注")
	private String description;

    @ApiModelProperty(value = "状态")
	private Integer status;

	@TableField(value = "create_by_id", fill = FieldFill.INSERT)
	private Long createById;

	@TableField(value = "create_by_name", fill = FieldFill.INSERT)
	private String createByName;

	@TableField(value = "create_time", fill = FieldFill.INSERT)
	private Date createTime;

	@TableField(value = "update_by_id", fill = FieldFill.INSERT)
	private Long updateById;

	@TableField(value = "update_by_name", fill = FieldFill.INSERT)
	private String updateByName;

	@TableField(value = "update_time", fill = FieldFill.INSERT)
	private Date updateTime;

	@TableField("org_id")
	private Long orgId;

	@TableField("company_id")
	private Long companyId;

	@TableField("site_id")
	private Long siteId;

    @ApiModelProperty(value = "顶层节点id")
	@TableField("root_id")
	private Long rootId;

    @ApiModelProperty(value = "排序")
	private Integer sort;

	private String path;

	@Override
	protected Serializable pkVal() {
		// TODO Auto-generated method stub
        return this.id;
	}
}
