package com.yizhi.album.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.yizhi.album.application.domain.Album;
import com.yizhi.album.application.vo.AlbumActivityVo;
import com.yizhi.album.application.vo.AlbumThemeVo;
import com.yizhi.album.application.vo.ApiListAlbumVo;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.session.RowBounds;

import java.util.Date;
import java.util.List;

/**
 * <p>
 * 专辑表 Mapper 接口
 * </p>
 *
 * @author hc123
 * @since 2019-12-30
 */
public interface AlbumMapper extends BaseMapper<Album> {

	List<Album> searchPage(@Param("name") String name, @Param("alClassifyId") Long alClassifyId,
			@Param("status") Integer status, @Param("overed") Integer overed, @Param("companyId") Long companyId,
			@Param("siteId") Long siteId, Page<Album> page);

	Integer vailName(@Param(value = "id") Long id, @Param(value = "name") String name,
			@Param(value = "siteId") Long siteId);

	List<Album> selectAlbumList(@Param("name") String name,@Param(value = "ids") List<Long> ids, @Param("companyId") Long companyId,
			@Param("siteId") Long siteId);
	
	List<Album> selectAlbumPage(@Param("name") String name,@Param(value = "ids") List<Long> ids, @Param("companyId") Long companyId,
			@Param("siteId") Long siteId,Page<Album> page);

	List<ApiListAlbumVo> searchPageSubClassify(@Param("name") String name, @Param("classifyIds") List<Long> classifyIds,
											   @Param("ids") List<Long> ids, @Param("companyId") Long companyId, @Param("siteId") Long siteId,
											   RowBounds rowBounds);

	List<Long> getCourseIds(@Param(value = "id") Long id);

	List<Long> getMyStudyList(@Param(value = "siteId") Long siteId, @Param(value = "accountId") Long accountId,Page<Long> page);

	Integer finished(@Param(value = "ids") List<Long> ids,@Param(value = "albumId") Long albumId, @Param(value = "accountId") Long accountId,
			@Param(value = "siteId") Long siteId);

	Integer unLockNum(@Param(value = "albumId") Long albumId);

	List<AlbumThemeVo> geThemeVos(@Param(value = "albumId") Long albumId, @Param(value = "type") Integer type);

	List<AlbumActivityVo> getActivityVos(@Param(value = "albumId") Long albumId, @Param(value = "type") Integer type,
										 @Param(value = "display") Integer display);

	List<Long> getLockList();

	List<ApiListAlbumVo> getMySubscribePage(@Param("ids") List<Long> ids, Page<ApiListAlbumVo> page);
	
	List<Long> getAllAlbums(@Param("companyId") Long companyId, @Param("siteId") Long siteId);
	
	List<Long> getIdsByAlbumId(@Param(value = "albumId") Long albumId);
	
	Integer getMyAlbumNum(@Param(value = "siteId") Long siteId, @Param(value = "accountId") Long accountId);
	
	Integer getSubscribeNum(@Param("ids") List<Long> ids);

	List<Long> getIdsByDate(@Param("currentDate") Date currentDate, @Param("siteId") Long siteId);

	List<Album> getPageToCalendar(@Param("passIds") List<Long> passIds,
									   @Param("albumIdsFromVisibeRange") List<Long> albumIdsFromVisibeRange,
									   @Param("currentDate") Date currentDate,
									   @Param("siteId") Long siteId,
									   Page page);
	Integer getPageToCalendarNum(@Param("passIds") List<Long> passIds,
								 @Param("albumIdsFromVisibeRange") List<Long> albumIdsFromVisibeRange,
								 @Param("currentDate") Date currentDate,
								 @Param("siteId") Long siteId);

	/**
	 * 获取已完结状态下的专辑内课程数
	 * @param albumId 专辑id
	 */
    Long getAlbumTotalCourseCount(@Param("albumId") Long albumId);
}
